package com.eactive.eai.batch.job.jobItem.ssnet;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_SSNBT_0600 extends DefaultTelegram implements TelegramService
{
    private Properties telegramInfo;
    private Properties jobInfo;
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    /**
     * 생성자
     */
    public SEND_SSNBT_0600() {
        //LOGIN 요구
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이 - 아데나 장비와 TCP통신을 위한 전문길이 필드
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TRANSACTION CODE
            //- 신/구 고객을 구분하기 위한 코드
            //- 기존고객코드 : EG01, EG05(구버젼 IBM tr id)
            //- EG01,EG05를 제외하고는 모두 신규고객(Space처리)
            //compileField(1, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[1]);
            compileField(1, "", this.al_FieldProps[1]);

            //전문종별코드. 전문기능을 나타내는 코드 ('0600'/'0610')
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 : 전문의 처리결과를 나타내는 코드로 REQUEST전문에는 '0' 을 SET 하며
            //RESPONSE 전문에는 해당내용을 SET 한다.
            //'000' = 정상 '310' = 송신자 계정오류 '001' = 송신집계오류
            //'320' = 송신자 ID 오류 '330' = 송신자 PSWD오류 '010' = NUMERIC오류
            //'340' = 수신자계정오류 '350' = 수산자 ID오류 '999' = 기타오류
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //고객코드 - 현재 space 처리
            compileField(4, "", this.al_FieldProps[4]);
            
            //SOURCE ACCOUNT - 본인의 그룹 ID
            compileField(5, telegramInfo.getProperty(TelegramKeys.SSNET_GROUP_ID), this.al_FieldProps[5]);

            //SOURCE USER-ID - 본인의 ID
            compileField(6, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[6]);

            //SOURCE PASSOWRD - 본인의 PASSWORD
            compileField(7, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[7]);

            //DEST ACCOUNT - 상대방 그룹 ID
            compileField(8, jobInfo.getProperty(TelegramKeys.SSNET_GROUP_ID), this.al_FieldProps[8]);

            //DEST USER-ID - 상대방 ID
            compileField(9, jobInfo.getProperty(TelegramKeys.SSNET_USER_ID), this.al_FieldProps[9]);

            //DEST TYPE - 수신자 TYPE(무조건 'D'를 입력)
            compileField(10, TelegramKeys.SSNET_DEST_TYPE, this.al_FieldProps[10]);

            //USER MSG CLASS
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND)) {
                compileField(11, jobInfo.getProperty(TelegramKeys.SSNET_SEND_MSG_ID), this.al_FieldProps[11]);
            }else{
                compileField(11, jobInfo.getProperty(TelegramKeys.SSNET_RECV_MSG_ID), this.al_FieldProps[11]);
            }

            //업무관리정보 - '001' = 업무개시 '002' = 파일 수신요구 '003' = 업무종료 '310' = 업무장애 회복확인
            compileField(12, this.getFldOpCode(), this.al_FieldProps[12]);

            //송신집계내역 - 송신한 마지막 0320전문의 일련번호,
            compileField(13, "" + batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[13]);
            
            //# ARCHIVE REF-ID 수신요구 SETTING(사용않함 → Space)
            compileField(14, "", this.al_FieldProps[14]);
            
            //# ARCHIVE 요구표시 ARCHIVE 수신요구시 'Y'로 SETTING(사용않함→Space)
            compileField(15, "", this.al_FieldProps[15]);
            
            //# MSG QUE 조회요구 MSG QUE 조회요구시 'Y'로 SETTING(사용않함→Space)
            compileField(16, "", this.al_FieldProps[16]);
            
            //# MSG CANCEL 요구 MSG CANCEL 조회요구시 'Y'로 SETTING(사용않함→Space)
            compileField(17, "", this.al_FieldProps[17]);
            
            //# GROUP 등록요구 GROUP 등록요구시 'Y'로 SETTING(사용않함→Space)
            compileField(18, "", this.al_FieldProps[18]);
            
            //Code 변환 여부 표시 - 코드변환시 'A', 미변환 송수신시 'E'로 SETTING
            String codeConv = TelegramKeys.SSNET_CODE_CONV_DEFAULT;
            if ( jobInfo.getProperty(TelegramKeys.SSNET_CODE_CONV_OPT)!= null &&
                 !jobInfo.getProperty(TelegramKeys.SSNET_CODE_CONV_OPT).equals("")	){
            	codeConv = jobInfo.getProperty(TelegramKeys.SSNET_CODE_CONV_OPT);
            }
            compileField(19, codeConv, this.al_FieldProps[19]);
            
            //결번 Check 간격 - 전문 몇건마다 결번 체크할 것인지 결정 (예:100건마다 -> '100'),
            //최대 999,100건 이하는 반드시 앞자리에 0을 표시(예: 050, 020)
            //※ 70 이하의 값을 권장함
            compileField(20, "" + batchDoc.getBatchMsg().getHeader().getBlockSize(), this.al_FieldProps[20]);
            
            //고객 시스템 TRAN-ID - 고객시스템의 TRANS-ID를 SETTING
            compileField(21, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[21]);

            //결번 CHK요구표시 - 'Y'(고정값)
            compileField(22, TelegramKeys.SSNET_MISS_CHK_REQ, this.al_FieldProps[22]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
    	return REAL_SEND_LENGTH;
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            jobInfo = getJobInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            createFile();
            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            int fldLen = getCalculatedLength(idx);
            for (int inx = 0; inx < fldLen; inx++) {
				data[inx] = ' ';
			}

            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);

            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return 7;
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += getCalculatedLength(this.al_Field.size()-1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private boolean createFile()
    {
    	try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }

            String fileName = fileDir + fileNm;

            File file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                logger.debug("{} the File["+fileDir+"/"+file.getName()+"] does not exist!!!", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }
			//DB로그에 남길 파일 헤더,트레일러 내용 설정
			super.setFileHeaderAndTrailer(file);

            batchDoc.getBatchMsg().getHeader().setFileSize(file.length());
            logger.info("{} File [" + file.getName() + "] Size =" + file.length(), logHeader);
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(12);
    }
}

